# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetDestinationCertificatesResult',
    'AwaitableGetDestinationCertificatesResult',
    'get_destination_certificates',
    'get_destination_certificates_output',
]

@pulumi.output_type
class GetDestinationCertificatesResult:
    """
    A collection of values returned by getDestinationCertificates.
    """
    def __init__(__self__, certificates=None, destination_id=None, id=None):
        if certificates and not isinstance(certificates, list):
            raise TypeError("Expected argument 'certificates' to be a list")
        pulumi.set(__self__, "certificates", certificates)
        if destination_id and not isinstance(destination_id, str):
            raise TypeError("Expected argument 'destination_id' to be a str")
        pulumi.set(__self__, "destination_id", destination_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def certificates(self) -> Optional[Sequence['outputs.GetDestinationCertificatesCertificateResult']]:
        return pulumi.get(self, "certificates")

    @property
    @pulumi.getter(name="destinationId")
    def destination_id(self) -> str:
        """
        The unique identifier for the target destination within the Fivetran system.
        """
        return pulumi.get(self, "destination_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The unique identifier for the resource. Equal to target destination id.
        """
        return pulumi.get(self, "id")


class AwaitableGetDestinationCertificatesResult(GetDestinationCertificatesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDestinationCertificatesResult(
            certificates=self.certificates,
            destination_id=self.destination_id,
            id=self.id)


def get_destination_certificates(certificates: Optional[Sequence[pulumi.InputType['GetDestinationCertificatesCertificateArgs']]] = None,
                                 id: Optional[str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDestinationCertificatesResult:
    """
    Use this data source to access information about an existing resource.

    :param str id: The unique identifier for the resource. Equal to target destination id.
    """
    __args__ = dict()
    __args__['certificates'] = certificates
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('fivetran:index/getDestinationCertificates:getDestinationCertificates', __args__, opts=opts, typ=GetDestinationCertificatesResult).value

    return AwaitableGetDestinationCertificatesResult(
        certificates=pulumi.get(__ret__, 'certificates'),
        destination_id=pulumi.get(__ret__, 'destination_id'),
        id=pulumi.get(__ret__, 'id'))


@_utilities.lift_output_func(get_destination_certificates)
def get_destination_certificates_output(certificates: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetDestinationCertificatesCertificateArgs']]]]] = None,
                                        id: Optional[pulumi.Input[str]] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDestinationCertificatesResult]:
    """
    Use this data source to access information about an existing resource.

    :param str id: The unique identifier for the resource. Equal to target destination id.
    """
    ...
