# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetDestinationFingerprintsResult',
    'AwaitableGetDestinationFingerprintsResult',
    'get_destination_fingerprints',
    'get_destination_fingerprints_output',
]

@pulumi.output_type
class GetDestinationFingerprintsResult:
    """
    A collection of values returned by getDestinationFingerprints.
    """
    def __init__(__self__, destination_id=None, fingerprints=None, id=None):
        if destination_id and not isinstance(destination_id, str):
            raise TypeError("Expected argument 'destination_id' to be a str")
        pulumi.set(__self__, "destination_id", destination_id)
        if fingerprints and not isinstance(fingerprints, list):
            raise TypeError("Expected argument 'fingerprints' to be a list")
        pulumi.set(__self__, "fingerprints", fingerprints)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter(name="destinationId")
    def destination_id(self) -> str:
        """
        The unique identifier for the target destination within the Fivetran system.
        """
        return pulumi.get(self, "destination_id")

    @property
    @pulumi.getter
    def fingerprints(self) -> Optional[Sequence['outputs.GetDestinationFingerprintsFingerprintResult']]:
        return pulumi.get(self, "fingerprints")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The unique identifier for the resource. Equal to target destination id.
        """
        return pulumi.get(self, "id")


class AwaitableGetDestinationFingerprintsResult(GetDestinationFingerprintsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDestinationFingerprintsResult(
            destination_id=self.destination_id,
            fingerprints=self.fingerprints,
            id=self.id)


def get_destination_fingerprints(fingerprints: Optional[Sequence[pulumi.InputType['GetDestinationFingerprintsFingerprintArgs']]] = None,
                                 id: Optional[str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDestinationFingerprintsResult:
    """
    This data source returns a list of SSH fingerprints approved for specified destination.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fivetran as fivetran

    destination_fingerprints = fivetran.get_destination_fingerprints(id="destination_id")
    ```


    :param str id: The unique identifier for the resource. Equal to target destination id.
    """
    __args__ = dict()
    __args__['fingerprints'] = fingerprints
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('fivetran:index/getDestinationFingerprints:getDestinationFingerprints', __args__, opts=opts, typ=GetDestinationFingerprintsResult).value

    return AwaitableGetDestinationFingerprintsResult(
        destination_id=pulumi.get(__ret__, 'destination_id'),
        fingerprints=pulumi.get(__ret__, 'fingerprints'),
        id=pulumi.get(__ret__, 'id'))


@_utilities.lift_output_func(get_destination_fingerprints)
def get_destination_fingerprints_output(fingerprints: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetDestinationFingerprintsFingerprintArgs']]]]] = None,
                                        id: Optional[pulumi.Input[str]] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDestinationFingerprintsResult]:
    """
    This data source returns a list of SSH fingerprints approved for specified destination.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fivetran as fivetran

    destination_fingerprints = fivetran.get_destination_fingerprints(id="destination_id")
    ```


    :param str id: The unique identifier for the resource. Equal to target destination id.
    """
    ...
