# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetTeamUserMembershipsResult',
    'AwaitableGetTeamUserMembershipsResult',
    'get_team_user_memberships',
    'get_team_user_memberships_output',
]

@pulumi.output_type
class GetTeamUserMembershipsResult:
    """
    A collection of values returned by getTeamUserMemberships.
    """
    def __init__(__self__, id=None, team_id=None, users=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if team_id and not isinstance(team_id, str):
            raise TypeError("Expected argument 'team_id' to be a str")
        pulumi.set(__self__, "team_id", team_id)
        if users and not isinstance(users, list):
            raise TypeError("Expected argument 'users' to be a list")
        pulumi.set(__self__, "users", users)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The unique identifier for resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="teamId")
    def team_id(self) -> str:
        """
        The unique identifier for the team within your account.
        """
        return pulumi.get(self, "team_id")

    @property
    @pulumi.getter
    def users(self) -> Optional[Sequence['outputs.GetTeamUserMembershipsUserResult']]:
        return pulumi.get(self, "users")


class AwaitableGetTeamUserMembershipsResult(GetTeamUserMembershipsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTeamUserMembershipsResult(
            id=self.id,
            team_id=self.team_id,
            users=self.users)


def get_team_user_memberships(team_id: Optional[str] = None,
                              users: Optional[Sequence[pulumi.InputType['GetTeamUserMembershipsUserArgs']]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTeamUserMembershipsResult:
    """
    This data source returns a list of user memberships within team object.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fivetran as fivetran

    team_user_memberships = fivetran.get_team_user_memberships(team_id="team_id")
    ```


    :param str team_id: The unique identifier for the team within your account.
    """
    __args__ = dict()
    __args__['teamId'] = team_id
    __args__['users'] = users
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('fivetran:index/getTeamUserMemberships:getTeamUserMemberships', __args__, opts=opts, typ=GetTeamUserMembershipsResult).value

    return AwaitableGetTeamUserMembershipsResult(
        id=pulumi.get(__ret__, 'id'),
        team_id=pulumi.get(__ret__, 'team_id'),
        users=pulumi.get(__ret__, 'users'))


@_utilities.lift_output_func(get_team_user_memberships)
def get_team_user_memberships_output(team_id: Optional[pulumi.Input[str]] = None,
                                     users: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetTeamUserMembershipsUserArgs']]]]] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetTeamUserMembershipsResult]:
    """
    This data source returns a list of user memberships within team object.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fivetran as fivetran

    team_user_memberships = fivetran.get_team_user_memberships(team_id="team_id")
    ```


    :param str team_id: The unique identifier for the team within your account.
    """
    ...
