# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetUserConnectorMembershipsResult',
    'AwaitableGetUserConnectorMembershipsResult',
    'get_user_connector_memberships',
    'get_user_connector_memberships_output',
]

@pulumi.output_type
class GetUserConnectorMembershipsResult:
    """
    A collection of values returned by getUserConnectorMemberships.
    """
    def __init__(__self__, connectors=None, id=None, user_id=None):
        if connectors and not isinstance(connectors, list):
            raise TypeError("Expected argument 'connectors' to be a list")
        pulumi.set(__self__, "connectors", connectors)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if user_id and not isinstance(user_id, str):
            raise TypeError("Expected argument 'user_id' to be a str")
        pulumi.set(__self__, "user_id", user_id)

    @property
    @pulumi.getter
    def connectors(self) -> Optional[Sequence['outputs.GetUserConnectorMembershipsConnectorResult']]:
        return pulumi.get(self, "connectors")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> str:
        """
        The unique identifier for the user within your account.
        """
        return pulumi.get(self, "user_id")


class AwaitableGetUserConnectorMembershipsResult(GetUserConnectorMembershipsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetUserConnectorMembershipsResult(
            connectors=self.connectors,
            id=self.id,
            user_id=self.user_id)


def get_user_connector_memberships(connectors: Optional[Sequence[pulumi.InputType['GetUserConnectorMembershipsConnectorArgs']]] = None,
                                   user_id: Optional[str] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetUserConnectorMembershipsResult:
    """
    This data source returns a connector membership for user.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fivetran as fivetran

    user_connector_membership = fivetran.get_user_connector_memberships(user_id="user_id")
    ```


    :param str user_id: The unique identifier for the user within your account.
    """
    __args__ = dict()
    __args__['connectors'] = connectors
    __args__['userId'] = user_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('fivetran:index/getUserConnectorMemberships:getUserConnectorMemberships', __args__, opts=opts, typ=GetUserConnectorMembershipsResult).value

    return AwaitableGetUserConnectorMembershipsResult(
        connectors=pulumi.get(__ret__, 'connectors'),
        id=pulumi.get(__ret__, 'id'),
        user_id=pulumi.get(__ret__, 'user_id'))


@_utilities.lift_output_func(get_user_connector_memberships)
def get_user_connector_memberships_output(connectors: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetUserConnectorMembershipsConnectorArgs']]]]] = None,
                                          user_id: Optional[pulumi.Input[str]] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetUserConnectorMembershipsResult]:
    """
    This data source returns a connector membership for user.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fivetran as fivetran

    user_connector_membership = fivetran.get_user_connector_memberships(user_id="user_id")
    ```


    :param str user_id: The unique identifier for the user within your account.
    """
    ...
